# AUTOGENERATED! DO NOT EDIT! File to edit: ../../../nbs/dspy/dspy.predict.cok.ipynb.

# %% auto 0
__all__ = ['log', 'ChainOfKnowledge']

# %% ../../../nbs/dspy/dspy.predict.cok.ipynb 3
import dspy
from dspy.primitives.program import Module
from dspy.signatures.signature import ensure_signature

from ...logging import get_logger

log = get_logger(__name__)

# %% ../../../nbs/dspy/dspy.predict.cok.ipynb 4
class ChainOfKnowledge(Module):
    def __init__(self, signature, rationale_type=None, activated=True, **config):
        super().__init__()

        self.activated = activated

        self.signature = signature = ensure_signature(signature)

        prefix = "Let's list evidence triples in the form of (subject, relation, object) and then identify key logical connections or observations linking the evidence triples to the answer"
        desc = "${evidence_triples}\n${explanation_hints}"
        rationale_type = rationale_type or dspy.OutputField(prefix=prefix, desc=desc)

        # Add fields
        extended_signature = signature.prepend("Explanation hints", rationale_type, type_=str)
        extended_signature = extended_signature.prepend("Evidence triples", rationale_type, type_=str)

        self._predict = dspy.Predict(extended_signature, **config)
        self._predict.extended_signature = extended_signature

    def forward(self, **kwargs):
        assert self.activated in [True, False]

        signature = kwargs.pop("new_signature", self._predict.extended_signature if self.activated else self.signature)
        return self._predict(signature=signature, **kwargs)

    @property
    def demos(self):
        return self._predict.demos

    @property
    def extended_signature(self):
        return self._predict.extended_signature
